# Use --define 'noxlc 1' on the command line to use gcc
%{!?noxlc:%define XLC 1}
%{?noxlc:%define XLC 0}

%define kde_release 3.4.3
%define qt_release 3.3.5

%define prefix %{_prefix}/kde

Name: koffice
Summary: Set of office applications for KDE
Version: 1.4.2
Release: 1
Epoch: 2
Source: ftp://ftp.kde.org/pub/kde/stable/%{name}-%{version}/src/%{name}-%{version}.tar.bz2
Patch0: %{name}-%{version}-kde-common.patch
Patch1: %{name}-%{version}-aix.patch
Patch2: %{name}-%{version}-xlc.patch
Group: User Interface/Desktops
Copyright: GPL
BuildRoot: %{_tmppath}/%{name}-buildroot
Requires: kdelibs >= %{kde_release}
Requires: python >= 2.3.4
Requires: freetype2
BuildRequires: automake >= 1.9
BuildRequires: autoconf >= 2.58
BuildRequires: python-devel >= 2.3.4
BuildRequires: freetype2-devel
BuildRequires: kdelibs-devel >= %{kde_release}


%description
Office applications for the K Desktop Environment.
KOffice contains KWord (word processor), KSpread (spreadsheet), KPresenter
(Presentations) and KChart (diagram generator).


%prep
rm -rf $RPM_BUILD_ROOT
%setup -q
# Common patches.
%patch0 -p0 -b .kde-common
%patch1 -p0 -b .aix
# Per-compiler patches.  These will break (or are untested) on the other.
%if %{XLC} == 1
%patch2 -p0 -b .xlc 
%endif

%if %{XLC} == 0
  # Deoptimize.  Temporary until compiler is in better shape.
  for file in `find . -print | xargs grep -l '\-O2'`; do
    cp $file $file.withO2
    sed -e 's/\-O2/-O0/g' < $file.withO2 > $file
  done
%endif

#ln -s /usr/bin/automake automake-1.6

%build
%{!?noxlc: export CC=xlc_r CXX=xlC_r}
export KDEDIR=%{prefix}
export QTDIR=%{_prefix}/qt
export GENFLAGS="-DHAVE_VSNPRINTF -qlanglvl=redefmac:oldmath"
export CXXFLAGS="$GENFLAGS %{!?noxlc: -qrtti=all -qbitfields=signed}" CFLAGS="$GENFLAGS %{!?noxlc: -Dinline=_Inline}"
#FIXME: Getting errors about mismatched autoconf versions.  This shouldn't be necessary.
aclocal; autoconf
./configure  \
	--prefix=%{prefix} %{!?noxlc: --with-extra-includes=/usr/vacpp/include} \
	--with-pythondir=%{_prefix} \
	--disable-debug %{?noxlc: --enable-final} \
	--disable-largefile

#FIXME: Trying to make up for the 'KDE_CXXFLAGS += -include..." in kexi's makefiles.
echo "#include <kexi_global.h>" > tmp.h
for file in `find kexi -name "*.c*"`; do
  cat tmp.h $file > $file.new
  mv $file.new $file
done
echo "#include <kexidb/global.h>" > tmp.h
for file in `ls -C1 kexi/kexidb/drivers/sqlite2/*.c* kexi/kexidb/drivers/sqlite/*.c* kexi/kexidb/*.c*`; do
  cat tmp.h $file > $file.new
  mv $file.new $file
done
rm tmp.h

#FIXME: -Wnounresolved in kexi's makefiles.
find kexi -name "Makefile.am" | xargs perl -pi -e 's/-Wnounresolved//g'

make


%install
export DESTDIR=$RPM_BUILD_ROOT
make DESTDIR=$RPM_BUILD_ROOT install

# Stripping decreases size a lot!
%if %{XLC} == 0
  /usr/bin/strip $RPM_BUILD_ROOT%{prefix}/bin/* || :
%endif

mkdir -p $RPM_BUILD_ROOT/usr
ln -sf ..%{prefix} $RPM_BUILD_ROOT/usr

{
	cd $RPM_BUILD_ROOT
	find .%{prefix} -type d | \
                sed '1,2d;s,^\.,\%attr(-\,root\,root) \%dir ,' > \
		$RPM_BUILD_DIR/file.list.%{name}

	find . -type f | \
                sed -e 's,^\.,\%attr(-\,root\,root) ,' \
		-e '/\/config\//s|^|%config |' >> \
		$RPM_BUILD_DIR/file.list.%{name}

	find . -type l | \
                sed 's,^\.,\%attr(-\,root\,root) ,' >> \
		$RPM_BUILD_DIR/file.list.%{name}

        echo "%docdir" %{prefix}/share/doc >> \
                $RPM_BUILD_DIR/file.list.%{name}

	cd -
}


%clean
rm -rf $RPM_BUILD_ROOT $RPM_BUILD_DIR/file.list.%{name}


%files -f ../file.list.%{name} 


%changelog
* Mon Nov  7 2005 George Staikos <staikos@kde.org> 1.4.2-1
- 1.4.2

* Wed Oct  8 2003 George Staikos <staikos@kde.org> 1.2.1-2
- build on AIX 5.1 with Visual Age C++ 6.0

* Wed Feb 12 2003 Reza Arbab <arbab@austin.ibm.com> 1.2.1-1
- 1.2.1

* Wed Jun 19 2002 Reza Arbab <arbab@austin.ibm.com>
- koffice 1.2beta2 for KDE 3.0
- build with xlC

* Fri Feb 15 2002 Marc Stephenson <marc@austin.ibm.com>
- Rebuild with python 2.2

* Thu Aug 16 2001 Reza Arbab <arbab@austin.ibm.com>
- Update to 1.1

* Fri Jul 20 2001 David Clissold <cliss@austin.ibm.com>
- Missed removal of killustrator HTML files; grep them out.

* Tue Jul  3 2001 Marc Stephenson <marc@austin.ibm.com>
- Remove killustrator due to trademark objections from Adobe

* Fri Mar 23 2001 Marc Stephenson <marc@austin.ibm.com>
- Rebuild against new shared objects

* Wed Dec 20 2000 pkgmgr <pkgmgr@austin.ibm.com>
- Modify for AIX Freeware distribution

* Thu May 11 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- initial RPM
